#ifndef A_STRUCTURE_H
#define A_STRUCTURE_H

//--------------------------------------------------------------------------
/* +
 *    (Brenkman Andrey)
 *   17.05.2008
*/
//--------------------------------------------------------------------------

/*
    90%

   
       
*/

//--------------------------------------
//         
//   #if #endif
// unexpected tokens following preprocessor directive - expected a newline
#pragma warning(disable : 4067)

//       
//  'strtok'
// 'strtok': This function or variable may be unsafe. 
// Consider using strtok_s instead. To disable deprecation, 
// use _CRT_SECURE_NO_WARNINGS. See online help for details.
#pragma warning(disable : 4996)
//--------------------------------------


// unsigned __int8 : 0 to 255
//          __int8 : -128 to 127

// unsigned __int16 :  0 to 65535
//          __int16 : -32768 to 32767

// unsigned __int32 : 0 to 4294967295
//          __int32 : -2147483648 to 2147483647

// unsigned __int64 : 0 to 
//          __int64 : - to 


// Bitboard

const unsigned __int16 LENGTH_STRING = 65534; //    

// + 1 -        
//   : 
//  =    + 1

//     6 + 1
const unsigned __int8 MAX_NAME = 7;

//    63 + 1
const unsigned __int8 MAX_COORDINATE = 64;

//          100 + 1
const unsigned __int8 MAX_DEPTH = 101;

//      
const unsigned __int16 MAX_MOVE = 256;

const unsigned __int8 A8=56, B8=57, C8=58, D8=59, E8=60, F8=61, G8=62, H8=63;
const unsigned __int8 A7=48, B7=49, C7=50, D7=51, E7=52, F7=53, G7=54, H7=55;
const unsigned __int8 A6=40, B6=41, C6=42, D6=43, E6=44, F6=45, G6=46, H6=47;
const unsigned __int8 A5=32, B5=33, C5=34, D5=35, E5=36, F5=37, G5=38, H5=39;
const unsigned __int8 A4=24, B4=25, C4=26, D4=27, E4=28, F4=29, G4=30, H4=31;
const unsigned __int8 A3=16, B3=17, C3=18, D3=19, E3=20, F3=21, G3=22, H3=23;
const unsigned __int8 A2=8,  B2=9,  C2=10, D2=11, E2=12, F2=13, G2=14, H2=15;
const unsigned __int8 A1=0,  B1=1,  C1=2,  D1=3,  E1=4,  F1=5,  G1=6,  H1=7;


//  
struct T_Bitboard 
{
	//-------------------------------------------------
	//    
	//A8(56) B8(57) C8(58) D8(59) E8(60) F8(61) G8(62) H8(63)
	//A7(48) B7(49) C7(50) D7(51) E7(52) F7(53) G7(54) H7(55)
	//A6(40) B6(41) C6(42) D6(43) E6(44) F6(45) G6(46) H6(47)
	//A5(32) B5(33) C5(34) D5(35) E5(36) F5(37) G5(38) H5(39)
	//A4(24) B4(25) C4(26) D4(27) E4(28) F4(29) G4(30) H4(31)
	//A3(16) B3(17) C3(18) D3(19) E3(20) F3(21) G3(22) H3(23)
	//A2(8)  B2(9)  C2(10) D2(11) E2(12) F2(13) G2(14) H2(15)
	//A1(0)  B1(1)  C1(2)  D1(3)  E1(4)  F1(5)  G1(6)  H1(7)
	//

	//A1(LSB)-    H8(MSB)- 63 
	// ..     
	// H8(63) G8(62) F8(61) . . . . . .C1(2) B1(1) A1(0)
	//-------------------------------------------------
	// 
	//   64  
	//           
	//            
	//     
	unsigned __int64  all_piece;//  
	unsigned __int64  all_white_piece;//   
	unsigned __int64  all_black_piece;//   

	//-------------------------------------------------
	//  
	/*
	 
	0 -  
	1 -  
	2 -  
	3 - 
	4 -  
	5 -  
	6 - 
	*/
	//      
	unsigned __int64 white_piece[MAX_NAME];
	unsigned __int64 black_piece[MAX_NAME];

	//     
	unsigned __int8 white_name_from_coord[MAX_COORDINATE];
	unsigned __int8 black_name_from_coord[MAX_COORDINATE];

	//-------------------------------------------------
	//  
	//   0 -  1 - 
	bool colour_move;

	//     1/0
	bool taking_passage_yes;

	//    (  )
	//   - 0 , h - 7      
	unsigned __int8  taking_passage_x;

	//    
	//  '1' - 0 , '8' - 7         1
	unsigned __int8  taking_passage_y;

	//        1/0
	bool castling_Q;

	//       1/0
	bool castling_K;

	//       1/0
	bool castling_q;

	//      1/0
	bool castling_k;

	// 64  - 
	unsigned __int64 hash_key ;

	//     
	unsigned __int16 value_white_material ;

	//     
	unsigned __int16 value_black_material ;


};

//---------------------------------------------------------------------------
//    
struct T_list_surplus_moves
{
	__int32 move[MAX_MOVE];
	/*
	    move     ( 27 )
	--3 --      --6 --   --6 --     --6 --  --6 -- 
	              

	//-------------------------------------------------
	  ..   
	--6 -- 
	 

	0 -  
	1 -  
	2 -  
	3 - 
	4 -  
	5 -  
	6 - 

	 move =  
	  move & 63 ( 63  ...000111111)

	//-------------------------------------------------
	--6 --
	 

	0 -  
	1   
	2  
	3   
	4   
	5    

	12 -    
	13 -   
	14 -    
	15 -    

	22 -      
	23 -     
	24 -      
	25 -      
 
	 move = move | (  << 6)
	 (move>>6) & 63

	//-------------------------------------------------
	--6 --
	  (0 -63)
	 move = move | (  << 12)
	 (move>>12) & 63

	//-------------------------------------------------
	--6 --
	  (0 -63)
	 move = move | (  << 18)
	 (move>>18) & 63

	//-------------------------------------------------
	--3 -- 
	 
	0 -  
	1 -  
	2 -  
	3 - 
	4 -  
	5 -  
	6 - 
	 move = move | (  << 24)
	 (move>>24) & 7 ( 7  ...000111)
	*/

	//     
	__int32 sorting_score[MAX_MOVE];

	//         .   
	// (       )
	unsigned __int8 end_captures;

	//       ..  
	unsigned __int8 end_list;

};

//---------------------------------------------------------------------------
//    ()      
struct T_undo
{
	//      1/0
	bool return_taking_passage;

	//    (  ) 
	//   - 0 , h - 7      
	unsigned __int8  taking_passage_x;

	//    
	//  '1' - 0 , '8' - 7         1
	unsigned __int8  taking_passage_y;

	//      
	bool return_castling_Q;

	//      
	bool return_castling_K;

	//      
	bool return_castling_q;

	//      
	bool return_castling_k;

};

//---------------------------------------------------------------------------
//  
struct T_PV 
{
	//      T_list_surplus_moves
	__int32 move[MAX_DEPTH]; 

	//  
	__int32 score_move;

	//  
	unsigned __int8  depth_max;

};

//---------------------------------------------------------------------------

#endif // !defined D_STRUCTURE_H






